<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetCcdFeatureConfigReq StructType
 * @subpackage Structs
 */
class GetCcdFeatureConfigReq extends AbstractStructBase
{
    /**
     * The returnedTags
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var XCcdFeatureConfig
     */
    public $returnedTags;
    /**
     * The paramName
     * @var string
     */
    public $paramName;
    /**
     * The sequence
     * Meta informations extracted from the WSDL
     * - use: optional
     * @var int
     */
    public $sequence;
    /**
     * Constructor method for GetCcdFeatureConfigReq
     * @uses GetCcdFeatureConfigReq::setReturnedTags()
     * @uses GetCcdFeatureConfigReq::setParamName()
     * @uses GetCcdFeatureConfigReq::setSequence()
     * @param XCcdFeatureConfig $returnedTags
     * @param string $paramName
     * @param int $sequence
     */
    public function __construct(XCcdFeatureConfig $returnedTags = null, $paramName = null, $sequence = null)
    {
        $this
            ->setReturnedTags($returnedTags)
            ->setParamName($paramName)
            ->setSequence($sequence);
    }
    /**
     * Get returnedTags value
     * @return XCcdFeatureConfig
     */
    public function getReturnedTags()
    {
        return $this->returnedTags;
    }
    /**
     * Set returnedTags value
     * @param XCcdFeatureConfig $returnedTags
     * @return GetCcdFeatureConfigReq
     */
    public function setReturnedTags(XCcdFeatureConfig $returnedTags = null)
    {
        $this->returnedTags = $returnedTags;
        return $this;
    }
    /**
     * Get paramName value
     * @return string|null
     */
    public function getParamName()
    {
        return $this->paramName;
    }
    /**
     * Set paramName value
     * @param string $paramName
     * @return GetCcdFeatureConfigReq
     */
    public function setParamName($paramName = null)
    {
        // validation for constraint: string
        if (!is_null($paramName) && !is_string($paramName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($paramName)), __LINE__);
        }
        $this->paramName = $paramName;
        return $this;
    }
    /**
     * Get sequence value
     * @return int|null
     */
    public function getSequence()
    {
        return $this->sequence;
    }
    /**
     * Set sequence value
     * @param int $sequence
     * @return GetCcdFeatureConfigReq
     */
    public function setSequence($sequence = null)
    {
        // validation for constraint: int
        if (!is_null($sequence) && !is_numeric($sequence)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sequence)), __LINE__);
        }
        $this->sequence = $sequence;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return GetCcdFeatureConfigReq
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
